###################################################################################
#
# Author: Vechs
# Date: August 1, 2018
# Description: Governs temperature of players and does horrible things to them if they are too hot or cold.
# Minecraft Version: 1.12.2
# Code copyright Vechs 2018
#
###################################################################################
# determine map ambient temperature between -1000 and 1000, where 0 is perfect comfort
# determine temperature change rate - The higher this value, the more armor is needed to mitigate
# Full Leather - 7
# Full Iron - 15
# Full Diamond - 20
# Iceolation ambient: -700
# Iceolation Temperature change: 10

# drag players temperatures towards the MAP AMBIENT
scoreboard players remove @a[score_Temperature_min=-700,score_Temperature=1000] Temperature 10

# allow armor points to insulate the players by draging them towards 0
execute @a[score_Temperature_min=-1000,score_Temperature=-1] ~ ~ ~ scoreboard players operation @s Temperature += @s armor
execute @a[score_Temperature_min=1,score_Temperature=1000] ~ ~ ~ scoreboard players operation @s Temperature -= @s armor

# locate invincible, invisible armor stands with specific names and tags and perform temperature changes near them
# these armor stands may be viewed in spectator mode to locate them
# vas = Vechs Armor Stand, a prefix to greatly reduce the chances of name conflicts
# USEFUL COMMAND: /kill @e[type=armor_stand,r=10]
# USEFUL COMMAND: /summon armor_stand ~ ~1 ~ {CustomName:"vasWarm",Tags:["vas"],Marker:1b,Invisible:1,Invulnerable:1,NoAI:1,NoGravity:1}

execute @e[type=minecraft:armor_stand,name=vasWarm,tag=vas] ~ ~ ~ scoreboard players add @a[r=10] Temperature 5
execute @e[type=minecraft:armor_stand,name=vasHot,tag=vas] ~ ~ ~ scoreboard players add @a[r=10] Temperature 10
execute @e[type=minecraft:armor_stand,name=vasLargeWarm,tag=vas] ~ ~ ~ scoreboard players add @a[r=50] Temperature 5
execute @e[type=minecraft:armor_stand,name=vasLargeHot,tag=vas] ~ ~ ~ scoreboard players add @a[r=50] Temperature 10
execute @e[type=minecraft:armor_stand,name=vasCool,tag=vas] ~ ~ ~ scoreboard players remove @a[r=10] Temperature 5
execute @e[type=minecraft:armor_stand,name=vasCold,tag=vas] ~ ~ ~ scoreboard players remove @a[r=10] Temperature 10
execute @e[type=minecraft:armor_stand,name=vasLargeCool,tag=vas] ~ ~ ~ scoreboard players remove @a[r=50] Temperature 5
execute @e[type=minecraft:armor_stand,name=vasLargeCold,tag=vas] ~ ~ ~ scoreboard players remove @a[r=50] Temperature 10	

# locate monsters that have a temperature aura and perform temperature changes near them
# vae = Vechs Entity Tag, a prefix to greatly reduce the chances of name conflicts
execute @e[tag=vetCold] ~ ~ ~ scoreboard players remove @a[r=20] Temperature 10


# catch temperatures that are out of bounds and cap them at -1000 or 1000
scoreboard players set @a[score_Temperature=-1000] Temperature -1000
scoreboard players set @a[score_Temperature_min=1000] Temperature 1000

# identify players with 0 hitpoints and set their temperature to 0
scoreboard players set @a[score_deathCount_min=1] Temperature 0
scoreboard players add @a[score_deathCount_min=1] DeathCounter 1
scoreboard players set @a[score_deathCount_min=1] deathCount 0

# adjust temperature based on proximity to various environmental blocks
execute @a ~ ~ ~ function vsf:temperature_blocks

# make players in creative mode go to 0 temperature
# I've been constantly re-equipping armor even in creative mode while making this map WHY WAS THIS THE LAST THING I ADDED TO THE CODE OMG
scoreboard players set @a[m=creative] Temperature 0


# perform temperature effects based on temperature score
# Do not use any naseau effects because a lot of comments on YouTube requested it

# CHILLY
effect @a[score_Temperature_min=-300,score_Temperature=-100] minecraft:hunger 1 0 true

# COLD
effect @a[score_Temperature_min=-500,score_Temperature=-300] minecraft:hunger 4 0 true
effect @a[score_Temperature_min=-500,score_Temperature=-300] minecraft:slowness 4 0 true

# HYPOTHERMIC
effect @a[score_Temperature_min=-700,score_Temperature=-500] minecraft:hunger 4 2 true
effect @a[score_Temperature_min=-700,score_Temperature=-500] minecraft:slowness 4 2 true

# FROSTBITE
effect @a[score_Temperature_min=-900,score_Temperature=-700] minecraft:hunger 4 3 true
effect @a[score_Temperature_min=-900,score_Temperature=-700] minecraft:slowness 4 3 true
effect @a[score_Temperature_min=-900,score_Temperature=-700] minecraft:poison 4 3 true

# FROZEN
effect @a[score_Temperature_min=-1000,score_Temperature=-900] minecraft:hunger 4 9 true
effect @a[score_Temperature_min=-1000,score_Temperature=-900] minecraft:slowness 4 9 true
effect @a[score_Temperature_min=-1000,score_Temperature=-900] minecraft:wither 4 9 true
effect @a[score_Temperature_min=-1000,score_Temperature=-900] minecraft:blindness 4 9 true

# WARM
effect @a[score_Temperature_min=100,score_Temperature=300] minecraft:weakness 1 0 true

# HOT
effect @a[score_Temperature_min=300,score_Temperature=500] minecraft:weakness 4 0 true
effect @a[score_Temperature_min=300,score_Temperature=500] minecraft:mining_fatigue 4 0 true

# OVERHEATING
effect @a[score_Temperature_min=500,score_Temperature=700] minecraft:weakness 4 1 true
effect @a[score_Temperature_min=500,score_Temperature=700] minecraft:mining_fatigue 4 1 true

# HEATSTROKE
effect @a[score_Temperature_min=700,score_Temperature=900] minecraft:weakness 4 2 true
effect @a[score_Temperature_min=700,score_Temperature=900] minecraft:mining_fatigue 4 2 true
effect @a[score_Temperature_min=700,score_Temperature=900] minecraft:poison 4 3 true

# BURNING
effect @a[score_Temperature_min=900,score_Temperature=1000] minecraft:weakness 4 3 true
effect @a[score_Temperature_min=900,score_Temperature=1000] minecraft:mining_fatigue 4 3 true
effect @a[score_Temperature_min=900,score_Temperature=1000] minecraft:poison 4 3 true
execute @a[score_Temperature_min=900,score_Temperature=1000] ~ ~ ~ summon Arrow ~ ~2.2 ~ {Motion:[0.0,-1.0,0.0],Fire:120s}